
; Tunnel v1.0 by Joe Wingbermuehle

#define clrshd		4765h
#define dispg		4BEBh
#define clrscr		4755h
#define	PutC		4705h
#define	putmap		4701h
#define	putps		4715h
#define	disphl		4709h
#define	currow		800Ch
#define	curcol		800Dh
#define pencol		8252h
#define	penrow		8253h
#define homeup		4775h
#define clrgbuf		515Bh
#define bufcopy		5164h
#define	rindoff		4795h
#define	getk		4A18h
#define random		50B6h
#define fpmult		40AAh
#define convop1		4EFCh
#define	setxxop1	4A74h
#define	cpop1op2	4166h
#define ipoint		4AE8h
#define vputs		4781h
#define divhlbya	400Ch
#define dispop1a	51D4h
#define setxxxxop2	4A7Ch
#define op2toop1	41C2h
#define cphlde		4004h
#define iline		4AE4h
#define rclx		4EE8h
#define stox		4ED4h
#define setxxop2	4A78h
	.org		9327h

	call		rindoff
	call		clrgbuf
	call		clrscr
	ld		hl,770
	ld		(currow),hl
	ld		hl,abt1
	call		putps
	ld		hl,1283
	ld		(currow),hl
	ld		hl,abt2
	call		putps
	ld		hl,516
	ld		(currow),hl
	ld		hl,abt3
	call		putps
	ld		hl,7
	ld		(currow),hl
	ld		hl,abt4
	call		putps
	ld		hl,2567
	ld		(currow),hl
	call		rclx
	call		convop1
	ex		de,hl
	call		disphl
	ld		a,0		; set the memory refresh register to 0
	ld		r,a		; to make the random numbers more random
	
	call		wkey
	call		drwcar
	ld		h,1
	ld		bc,7680
	ld		d,b
	ld		e,63
	call		iline
	ld		bc,16640
	ld		d,b
	ld		e,63
	call		iline
main:	ld		a,(ovrflg)
	cp		0
	jr		nz,gmovr
	ld		a,(count)
	cp		10
	jr		nz,skp1
	ld		a,0
	ld		(count),a
	ld		hl,(score)
	inc		hl
	ld		(score),hl
	ld		a,(count2)
	inc		a
	ld		(count2),a
	cp		20
	jr		nz,skp1
	ld		a,(width)
	dec		a
	ld		(width),a
	ld		a,0
	ld		(count2),a
skp1:	call		bufcopy
	call		mdown
	call		ckcar
	ld		a,0FFh
        out		(1),a
	ld		a,0FEh
        out		(1),a
	in		a,(1)
	cp		253
	jp		z,mleft
	cp		251
	jr		z,mright
	ld		a,0FFh
        out		(1),a
	ld		a,0BFh
	out		(1),a
	in		a,(1)
	cp		191
	jp		z,pause
        cp		127
	jr		nz,main
gmovr:	call		clrgbuf
	call		clrscr
	ld		hl,770
	ld		(currow),hl
	ld		hl,gover
	call		putps
	ld		hl,515
	ld		(currow),hl
	ld		hl,scr
	call		putps
	ld		hl,(score)
	call		disphl
	ld		hl,(score)
	call		setxxxxop2
	call		rclx
	call		cpop1op2
	call		c,newhs
	call		wkey
	call		clrgbuf
	call		clrscr
	ret

newhs:	call		op2toop1
	call		stox
	ld		hl,261
	ld		(currow),hl
	ld		hl,nhs
	call		putps
	ret

mright:	call		drwcar
	ld		a,(car)
	cp		86
	jr		z,mrx
	inc		a
	ld		(car),a
mrx:	call		drwcar
	jp		main

mleft:	call		drwcar
	ld		a,(car)
	dec		a
	jr		z,mlx
	ld		(car),a
mlx:	call		drwcar
	jp		main

ckcar:	ld		d,3
	ld		c,13
	ld		a,(car)
	ld		b,a
	call		ipoint
	jr		z,cn1
	ld		a,1
	ld		(ovrflg),a
cn1:	ld		d,3
	ld		c,13
	ld		a,(car)
	add		a,7
	ld		b,a
	call		ipoint
	jr		z,cn2
	ld		a,1
	ld		(ovrflg),a
cn2:	ret

mdown:	call		drwcar
	ld		a,(count)
	inc		a
	ld		(count),a
	ld		de,911Dh	; scrolling begins
	ld		hl,9111h
	ld		bc,02F4h
	lddr				; scrolling ends!
	ld		a,r		; get a random number (mem refresh reg)
	and		3		; set a limit for it
	cp		1
	jr		nz,not1
	ld		a,(first)
	cp		1		; by using a cp here we make the tunnel move
	jr		z,mdc1		; almost the opposite way of the boat thing
	dec		a
	ld		(first),a
	jr		mdc1
not1:	cp		2
	jr		nz,mdc1
	ld		a,(first)
	cp		59
	jr		z,mdc1
	inc		a
	ld		(first),a
	jr		mdc1
mdc1:	ld		b,12
	ld		hl,8E29h
	ld		a,0
mdlp1:	ld		(hl),a
	inc		hl
	djnz		mdlp1
	ld		d,1
	ld		a,(first)
	ld		b,a
	ld		c,63
	call		ipoint
	ld		hl,width
	add		a,(hl)
	ld		b,a
	call		ipoint
	call		drwcar
	ret

pause:	call		wkey
	jp		main

wkey:	call		wrel
wkey2:	call		getk
	ld		a,0
	call		cpaop2
	jr		z,wkey2
	call		wrel
	ret

wrel:	call		getk
	ld		a,0
	call		cpaop2
	jr		nz,wrel
	ret

cpaop2:	call		setxxop1
	call		cpop1op2
	ret


; Thanks to Movax for this wonderful routine!
drwcar:	
	ld		e,50
	ld		l,e
	ld		h,0
	ld		d,h
	add		hl,de
	add		hl,de
	add		hl,hl
	add		hl,hl
	ld		a,(car)
	ld		e,a
	srl		e
	srl		e
	srl		e
	add		hl,de
	ld		de,8E29h
	add		hl,de
	ld		b,7
	and		b
	jr		z,align
; shift sprite if necessary
	ld		ix,cars
	ld		d,a
	ld		e,4
snal1:	ld		b,(ix+0)
	ld		c,0
	push		de
snal2:	srl		b
	rr		c
	dec		d
	jr		nz,snal2
	pop		de
	ld		a,b
	xor		(hl)
	ld		(hl),a
	inc		hl
	ld		a,c
	xor		(hl)
	ld		(hl),a
	ld		bc,11
	add		hl,bc
	inc		ix
	dec		e
	jr		nz,snal1
	jp		sprtx
align:	ld		de,cars
	ld		b,4
salp:	ld		a,(de)
	xor		(hl)
	ld		(hl),a
	inc		de
	push		bc
	ld		bc,12
	add		hl,bc
	pop		bc
	djnz		salp
sprtx:	ret

cars:	.db		00010000b
	.db		00111000b
	.db		01111100b
	.db		11101110b

first:	.db		30
width:	.db		35	; width of tunnel
car:	.db		40	; the x location of the car
ovrflg:	.db		00h
score:	.dw		0000h
count:	.db		00h
count2:	.db		00h
gover:	.db		9,"Game Over"
scr:	.db		6,"Score:"
nhs:	.db		14,"New High Score"
abt1:	.db		11,"Tunnel v1.0"
abt2:	.db		6,"by Joe"
abt3:	.db		13,"Wingbermuehle"
abt4:	.db		10,"HighScore:"

.end
END
